import java.math.BigInteger;
import java.util.Scanner;

public class PalindromsBigInt {

	static Scanner sc = new Scanner(System.in);
	
	public static void main(String[] args) {
	//while(sc.hasNext()){
		/**/System.out.print("Zadej cislo: ");
		String s = sc.next();
		int z = 2;
		for(int m = 2; m <= 15; m++){
			for(int n = 0; n < s.length(); n++){
				if(charToInt(s.charAt(n)) >= m) {
					z++; break;
				}
			}
		}
		for(int i = 15; i >= z; i--){
			int k = 0; //pocet kroku
			String x = s;
			/**/System.out.println("\n\nFOR "+i+":");
			while(!isPalindrom(x)){
				BigInteger q1 = new BigInteger("0"), q2 = new BigInteger("0");
				q1 = q1.add(toDec(i,x));
				q2 = q2.add(toDec(i,new StringBuffer(x).reverse().toString()));
				/**/System.out.println("   "+(q1)+" + "+(q2)+" = ");
				/**/System.out.println("in 10: "+q1.add(q2));
				/**/System.out.println("in "+i+": "+(x = fromDec(i,q1.add(q2))));
				x = fromDec(i,q1.add(q2));
				/**/System.out.print("steps: ");
				k++;
			}
			System.out.print(k+" ");
		}
		for(int i = z-1; i >= 2; i--){
			System.out.print("? ");
		}
		System.out.println();
	//}
	}
	
	static boolean isPalindrom(String s){
		int d = s.length()-1;
		for(int i = 0; i < s.length()/2; i++){
			if(s.charAt(i) != s.charAt(d-i)) {
				return false;
			}
		}
		return true;
	}
	
	static long mocnina(int cislo, int mocnitel){
		long result = 1;
		for (int i = 1; i <= mocnitel; i++) {
			result *= cislo;
		}
		return result;
	}
	
	static BigInteger toDec(int soustava, String number){
		BigInteger result = new BigInteger(""+0); //vysledek
		int mocnina = 0;
		for(int i = number.length()-1; i >= 0; i--){
			BigInteger numeral = new BigInteger(""+charToInt(number.charAt(i)));
			BigInteger cislo = numeral.multiply(new BigInteger(""+mocnina(soustava, mocnina)));
			result = result.add(cislo);
			//result += numeral * mocnina(soustava, mocnina);
			//**/System.out.println(number.charAt(i)+" toInt "+numeral+" * "+mocnina(soustava, mocnina)+" = "+result);
			mocnina++;
		}
		return result;
	}
	static int charToInt(char znak){
		if(znak >= 48 && znak <= 57) return znak - 48; //cisla
		else return znak - 65 + 10; //pismena
	}
	
	
	static String fromDec(int soustava, BigInteger number){
		String result = "";
		while(number.toString().compareTo("0") != 0){
			int zbytek = number.mod(new BigInteger(""+soustava)).intValue();
			number = number.divide(new BigInteger(""+soustava)); //dalsi pozice v zadane soustave
			result = intToChar(zbytek) + result;
		}
		return result;
	}
	static char intToChar(int cislo) {
		if(cislo >= 0 && cislo < 10) return (char)(48 + cislo); //cisla
		else return (char)(65 + cislo - 10); //pismena
	}

}
